// -*- C++ -*-


#pragma once

#include "lib/defs.h"
#if GOOPAX_HAVE_CUDA

#include "env.h"
#include "kernel.h"
#include "memory.h"
#include <cuda/include/cuda.h>
#include <string>

/**
 \addtogroup CUDA CUDA interoperability
\{
 */


namespace goopax {
namespace impl {
namespace interface {
extern "C" {
GOOPAX_DLL_EXPORT(3.0.0) errno_type goopax_E_get_cuda_device(CUdevice*, goopax_device_impl*) noexcept;
}
}

inline CUdevice get_cuda_device(goopax_device device)
{
    /// \ingroup CUDA
    /// get CUDA device from GOOPAX device
    /// \param device GOOPAX device
    /// \return CUDA device
    return if_call(interface::goopax_E_get_cuda_device, device.get_impl());
}

}

using impl::get_cuda_device;
}

/// \}

#endif
