// -*- C++ -*-


#pragma once

#include "pdefs.h"

#include <cstdint>
#include <vector>


#if defined(__GLIBCXX) || defined(__GLIBCXX__)
#define GOOPAX_HAVE_DEBUG_STL 1
#else
#define GOOPAX_HAVE_DEBUG_STL 0
#endif

#define GOOPAX_USE_DEBUG_STL (GOOPAX_HAVE_DEBUG_STL && GOOPAX_DEBUG)


#ifdef _MSC_VER
#define __PRETTY_FUNCTION__ __FUNCDNAME__
#define __BASE_FILE__ "<basefile not set>"
#endif


#ifndef GOOPAX_DLL_EXPORT
#if defined(_WIN32)

#if defined(BUILDING_GOOPAX)
#define GOOPAX_DLL_EXPORT(V) __declspec(dllexport)
#define GOOPAX_DLL_LOCAL
#else
#define GOOPAX_DLL_EXPORT(V)
#define GOOPAX_DLL_LOCAL
#endif

#else

#if defined(BUILDING_GOOPAX)
#define GOOPAX_DLL_EXPORT(V) __attribute__((__visibility__("default")))
#define GOOPAX_DLL_LOCAL __attribute__((__visibility__("hidden")))
#else
#define GOOPAX_DLL_EXPORT(V)
#define GOOPAX_DLL_LOCAL
#endif

#endif
#endif


#if defined(_MSC_VER) && _MSC_VER < 1900
#error "GOOPAX: Sorry, you need Visual Studio 2015 or newer."
#endif


#if (__cplusplus >= 201300 || defined(_MSC_VER))
#define GOOPAX_USE_CXX14 1
#else
#define GOOPAX_USE_CXX14 0
#endif

#if __cplusplus < 201700 && (!defined(__clang__) || __cplusplus < 201406L)
#define GOOPAX_CONSTEXPR_INSTANTIATION 1
#else
#define GOOPAX_CONSTEXPR_INSTANTIATION 0
#endif


namespace goopax {
namespace impl {

#ifdef __GNUC__
#define GOOPAX_GCC_ATTRIB(x) __attribute((x))
#define GOOPAX_EXPECT(x, n) __builtin_expect(x, n)
#else
#define GOOPAX_GCC_ATTRIB(x)
#define GOOPAX_EXPECT(x, n) x
#endif

#ifdef _MSC_VER
#define GOOPAX_CONSTEXPR constexpr
#if _MSC_VER < 1900
#define GOOPAX_DEPRECATED
#define GOOPAX_NORETURN
#endif
#else
#define GOOPAX_CONSTEXPR constexpr
#endif


#if (__cplusplus < 201300)
#define GOOPAX_DEPRECATED
#endif


#ifndef GOOPAX_DEPRECATED
#define GOOPAX_DEPRECATED [[deprecated]]
#endif

#ifndef GOOPAX_NORETURN
#define GOOPAX_NORETURN [[noreturn]]
#endif

#define GOOPAX_VERSION_ID (GOOPAX_VERSION_MAJOR * 10000 + GOOPAX_VERSION_MINOR * 100 + GOOPAX_VERSION_PATCH)


// FIXME: remove, perhaps
struct INITTEX_REINTERPRET
{};
struct INITTEX_FROMGL
{};
struct INITTEX_IMPL
{};


}
}
