// -*- C++ -*-

#pragma once
#include "gpu_defs.h"
#include "gpu_types.h"
#include "lib/param.h"


namespace goopax {
namespace impl {
namespace interface {
extern "C" {
GOOPAX_DLL_EXPORT(3.0.0) perfdata_math_entry_impl* goopax_perfdata_math_entry_create3(const Uint  version,
                                                                                        const char* vendor,
                                                                                        const char* name,
                                                                                        Uint year, Uint month, Uint day, const char* driver_version,
                                                                                        const Tfloat*       perfdata,
                                                                                        const Tint*         params,
                                                                                        const Tfloat*       mathdata,
                                                                                        const char* const*  funcnames,
                                                                                        const Tfloat* const deviceparams) noexcept;
}
}

struct perfdata_math_entry
{
    unique_ptr<struct perfdata_math_entry_impl, interface::goopax_deleter> impl;

    perfdata_math_entry(const perfdata_math_entry&) = delete;
    perfdata_math_entry& operator=(const perfdata_math_entry&) = delete;
    inline perfdata_math_entry(const Tuint version, const string& vendor,
                               const string& name,
                               Tuint year, Tuint month, Tuint day, const string& driver_version,
                               const Tfloat*      perfdata,
                               const Tint*        params,
                               const Tfloat*      mathdata,
                               const char* const* funcnames,
                               const Tfloat*      deviceparams = nullptr)
        : impl(interface::goopax_perfdata_math_entry_create3(version, vendor.c_str(), name.c_str(), year, month, day, driver_version.c_str(), perfdata, params, mathdata, funcnames, deviceparams))
    {}
};
}

}
